## mingw-w64-siesta-5.4.1-2.src.tar.zst

=== External/DFTD3/CMakeLists.txt ===
#
# s-dftd3 depends on a number of libraries
# They can be included as submodules in this directory,
# and this file takes care of the details.
#
# Originally we processed the dependencies in order, but
# now we just look for s-dftd3 and let its own build system
# (or cmake config file) start a search for the dependencies.
#
# It would be good to have an option to build only
# the library itself.

# Configuration of sub-project variables ----------------

# (Will be set to "" if the SIESTA option is not defined, thus
#  turning the 'option' setting inside DFTD3 into a no-op,
#  and effectively disabling the tests.)
# (If quotes are not used, the behavior might change.)
# set(WITH_TESTS "${SIESTA_WITH_DFTD3_TESTS}")
#
# It is clearer to put this here to set a default
#
option(SIESTA_WITH_DFTD3_TESTS "DFT-D3 tests" OFF)
set(WITH_TESTS ${SIESTA_WITH_DFTD3_TESTS})

#
# (How do we turn off the auxiliary tests for toml-f et al?)
#

# We need to forcefully disable OpenMP, s-dftd3 is defaulting to true for this.
set(WITH_OpenMP "${SIESTA_WITH_OPENMP}")

# -------------------------------------------------------

### Re-use information already found by Siesta itself
### and skip BLAS search in s-dftd3

if (TARGET BLAS::BLAS)
  # Re-use target
  set(BLAS_FOUND "TRUE")
elseif(TARGET LAPACK::LAPACK)
  # Create a BLAS wrapper target
  add_library("BLAS::BLAS" INTERFACE IMPORTED)
  target_link_libraries("BLAS::BLAS" INTERFACE LAPACK::LAPACK)
  set(BLAS_FOUND "TRUE")
endif()


# Just search for s-dftd3 ----------------------------------
#
# Use our own finders for possible s-dftd3 dependencies, as we can have source directories
# in places different from the expectation of s-dftd3's finders.
#
list(PREPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/Modules/DFTD3")
message(DEBUG "CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}")

# Define the source directory root
set(DFTD3_SOURCE_ROOT "${PROJECT_SOURCE_DIR}/External/DFTD3")

if (NOT TARGET s-dftd3::s-dftd3)

  # The REQUIRED flag might not be passed to the module... check
  find_package(Custom-s-dftd3 REQUIRED MODULE)

  if (TARGET s-dftd3::s-dftd3)
    # This is necessary in case a cmake package is found
    # for s-dftd3, as imported targets are not global by
    # default, and we are running this in a "subdirectory"
    # scope. If s-dftd3 is compiled ("source" method), this would not be
    # necessary, since we manually add the library as IMPORTED GLOBAL
    # in SiestaFindPackage.
    #
    set_target_properties(s-dftd3::s-dftd3
                          PROPERTIES
                          IMPORTED_GLOBAL TRUE)
  endif()
endif()
list(POP_FRONT CMAKE_MODULE_PATH)
# ---------------------------------------

=== External/ELSI-project/CMakeLists.txt ===

list(APPEND CMAKE_MESSAGE_CONTEXT elsi)

if(ELSI_ALLOW_PRECOMPILED)

  message(STATUS " ** Searching for pre-compiled ELSI library...")
  message(STATUS " ** ... You might need to define extra variables.")
  message(STATUS " ** ... Continue only if you know what you are doing.")

  # We need to know:
  #  -- whether ELSI uses an external ELPA library
  #  -- whether ELSI has GPU support

  list(APPEND CMAKE_MESSAGE_CONTEXT search-for-elsi)
  include(search_for_elsi)
  list(POP_BACK CMAKE_MESSAGE_CONTEXT)

  if (ELSI_FOUND)
    message(STATUS " ** ... found. Note that features available might vary")

    if (ELSI_WITH_PEXSI AND (NOT ELSI_HAS_PEXSI))
      message(STATUS "** Warning: Installed ELSI library does not have PEXSI")
      message(STATUS "** Warning: Falling back to compiling it from sub-project.")
      set(ELSI_FOUND FALSE)
    else()
      list(POP_BACK CMAKE_MESSAGE_CONTEXT)
      return()
    endif()
  endif()

endif()

# -- Use ELSI as a sub-project

# C and C++ standards applying
# Older standards tend to be more forgiving with some
# constructs. This is needed in the scotch library, for example,
# with modern versions of gcc.
# This is a more portable way to specify the
# standard level (instead of, for example -std=c99)
# 
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)


# To override internal option() statements with variables
# set by the parent project
set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
#
# To accept <PACKAGE>_ROOT (uppercase version) as hint
#
set(CMAKE_POLICY_DEFAULT_CMP0144 NEW)

# Note that ELPA2024 support has been removed from ELSI
# The 2021 version has been retained, but its use in Siesta has not been tested much,
# and it does not work on the Mac.
# It might not work for GPU either (missing .cu files -- to be reported upstream)
option(ELSI_WITH_ELPA2021 "Use 2021 ELPA in ELSI" FALSE)
if(APPLE AND ELSI_WITH_ELPA2021)
   message(FATAL_ERROR "ELPA2021 does not work on the Mac. Remove ELSI_WITH_ELPA2021.")
endif()

# Should these options be passed to the top level?
# Note that ELSI_WITH_PEXSI triggers the enabling of CXX, which can only be
# done at the top level. It is set to FALSE here.
#
option(ELSI_WITH_GPU "Use GPU in ELSI" FALSE)
option(ELSI_WITH_EXTERNAL_ELPA "Use an external ELPA library in ELSI" FALSE)
option(ELSI_WITH_PEXSI "Enable PEXSI in ELSI" FALSE)
option(ELSI_WITH_EXTERNAL_PEXSI "Use an external PEXSI library in ELSI" FALSE)
option(ELSI_WITH_TESTS "Compile (Fortran) tests in ELSI" TRUE)
option(ELSI_WITH_C_TESTS "Compile (C) tests in ELSI" FALSE)
option(ELSI_INSTALL_PKGCONFIG_FILE "Install pkgconfig file" FALSE)

# The ELSI subproject will also honor the variables for compiler options:
#
#  ELSI_Fortran_FLAGS
#  ELSI_C_FLAGS
#  ELSI_CXX_FLAGS
#
#  which will be inserted in the CMAKE_Lang_FLAGS_CONFIG variables, where
#  CONFIG is the (uppercase) value of CMAKE_BUILD_CONFIG.
#  (or the custom ELSI_CUSTOM if the build configuration is not defined)

# For GPU (currently only CUDA), the variables honored are:
#
# CMAKE_CUDA_ARCHITECTURES   (defaults to 80 (A100 class))
# CMAKE_CUDA_FLAGS           (see default below)
#

# Setting variables for ELSI subproject:

# So that we do not need to use the MPI compilers
# If this feature ever stops working, we can enable the following

if (FALSE)
  set(CMAKE_Fortran_COMPILER ${MPI_Fortran_COMPILER} CACHE STRING "new Fortran compiler")
  set(CMAKE_C_COMPILER ${MPI_C_COMPILER} CACHE STRING "new C compiler")
  set(CMAKE_CXX_COMPILER ${MPI_CXX_COMPILER} CACHE STRING "new CXX compiler")
else()
  set(ELSI_USE_FIND_PACKAGE_MPI ON)
endif()

# Setup proper dependency targets list for ELSI
set(ELSI_EXTERNAL_TARGETS)

# Note that when using ELSI_USE_FIND_PACKAGE_MPI, ELSI's CMake scripts add transitive
# dependencies to MPI::MPI_C and MPI::MPI_Fortran

list(APPEND ELSI_EXTERNAL_TARGETS SCALAPACK::SCALAPACK LAPACK::LAPACK)

#
# Options for built-in libs
#

# 2020 and 2021 are the only supported versions in ELSI as of now
# Actually, 2020 is recommended
if(ELSI_WITH_ELPA2021)
  message(WARNING "ELPA_2021 is not recommended. Falling back to 2020")
  ###  set(USE_ELPA_2021 ON)
endif()


if(ELSI_WITH_PEXSI)
  set(ENABLE_PEXSI ON)
  set(ELSI_HAS_PEXSI ON)
endif()
#
# Direct transcription of wrapper options to ELSI options via variables
#
set(ENABLE_TESTS ${ELSI_WITH_TESTS})
set(ENABLE_C_TESTS ${ELSI_WITH_C_TESTS})


# Handle external solver libraries in ELSI (just ELPA for now)

if(ELSI_WITH_EXTERNAL_ELPA)
  if (NOT TARGET Elpa::elpa)
    message(STATUS "Looking for pre-compiled ELPA library for ELSI sub-project...")
    find_package(CustomElpa)
    if (NOT ELPA_FOUND)
      message(WARNING "External ELPA library not found for ELSI sub-project. Falling back to internal ELPA in ELSI")
    endif()
  endif()

  if (TARGET Elpa::elpa)
    message(STATUS "Using external ELPA for ELSI compilation")
    list(APPEND ELSI_EXTERNAL_TARGETS Elpa::elpa)
    set(USE_EXTERNAL_ELPA ON)
    set(ELSI_HAS_EXTERNAL_ELPA ON)
  else()
    set(ELSI_HAS_EXTERNAL_ELPA OFF)
    set(ELPA_API_VERSION "20200000")
  endif()
endif()

# Logic for GPU support

if(ELSI_HAS_EXTERNAL_ELPA)
  if(ELPA_HAS_GPU_SUPPORT)
    message(STATUS "External ELPA library in use has GPU support (${ELPA_GPU_STRING})")
    set(ELSI_ELPA_HAS_GPU_SUPPORT TRUE)
    set(ELSI_ELPA_GPU_STRING ${ELPA_GPU_STRING})
    set(ELSI_ELPA_REAL_GPU_KERNEL ${ELPA_REAL_GPU_KERNEL})
    set(ELSI_ELPA_COMPLEX_GPU_KERNEL ${ELPA_COMPLEX_GPU_KERNEL})
  else()
    message(STATUS "External ELPA library in use has NO GPU support")
    # We could also error out here
    if(ELSI_WITH_GPU)
      message(WARNING "External ELPA library in use for ELSI has NO GPU support")
    endif()
    set(ELSI_ELPA_HAS_GPU_SUPPORT FALSE)
    set(ELSI_ELPA_GPU_STRING "no-gpu")
    set(ELSI_ELPA_REAL_GPU_KERNEL -1)
    set(ELSI_ELPA_COMPLEX_GPU_KERNEL -1)
  endif()
else(ELSI_HAS_EXTERNAL_ELPA)
  if(ELSI_WITH_GPU)
    # We will compile ELSI with GPU support. Currently, only CUDA
    set(USE_GPU_CUDA ON)

    if(NOT DEFINED CMAKE_CUDA_ARCHITECTURES)
      set(CMAKE_CUDA_ARCHITECTURES 80)
    endif()
    message(STATUS "CMAKE_CUDA_ARCHITECTURES: ${CMAKE_CUDA_ARCHITECTURES}")

    if(NOT DEFINED CMAKE_CUDA_FLAGS)
      set(CMAKE_CUDA_FLAGS "-arch=sm_${CMAKE_CUDA_ARCHITECTURES} -O3 -std=c++11")
    endif()
    message(STATUS "CMAKE_CUDA_FLAGS: ${CMAKE_CUDA_FLAGS}")

    find_package(CUDAToolkit REQUIRED)
    list(APPEND ELSI_EXTERNAL_TARGETS CUDA::cublasLt CUDA::cublas CUDA::cudart)
    if(ELSI_WITH_ELPA2021)
      set(ELSI_ELPA_GPU_STRING "nvidia-gpu")
      message(STATUS "** Using ELPA2021 within ELSI with GPU support")
      message(STATUS "** Note that it might not have all the needed files...")
    else()
      set(ELSI_ELPA_GPU_STRING "gpu")
      message(STATUS "Using ELPA2020 within ELSI with GPU support")
    endif()

    set(ELSI_HAS_CUDA ON)
    set(ELSI_ELPA_HAS_GPU_SUPPORT TRUE)
    set(ELSI_ELPA_REAL_GPU_KERNEL "ELPA_2STAGE_REAL_GPU")
    set(ELSI_ELPA_COMPLEX_GPU_KERNEL "ELPA_2STAGE_COMPLEX_GPU")
    message(STATUS "ELSI_ELPA_HAS_GPU_SUPPORT: ${ELSI_ELPA_HAS_GPU_SUPPORT}")
  else(ELSI_WITH_GPU)
    set(ELSI_HAS_CUDA OFF)
    set(ELSI_ELPA_HAS_GPU_SUPPORT FALSE)
    set(ELSI_ELPA_GPU_STRING "no-gpu")
    set(ELSI_ELPA_REAL_GPU_KERNEL -1)
    set(ELSI_ELPA_COMPLEX_GPU_KERNEL -1)
  endif(ELSI_WITH_GPU)
endif(ELSI_HAS_EXTERNAL_ELPA)

message(STATUS " ** External targets passed to ELSI:")

foreach(_tgt ${ELSI_EXTERNAL_TARGETS})
  message(STATUS " --> ${_tgt}")
endforeach()

# Pass this to the LIBS variable, which in ELSI will actually end up holding target names
# Note that it is important that this variable is not a cache variable in ELSI
# (It is not a cache variable when we use our patched version. Patch to be sent upstream)

set(LIBS ${ELSI_EXTERNAL_TARGETS})

include(FetchContent)

if(EXISTS "${PROJECT_SOURCE_DIR}/External/ELSI-project/elsi_interface/CMakeLists.txt")
  set(FETCHCONTENT_SOURCE_DIR_ELSI "${PROJECT_SOURCE_DIR}/External/ELSI-project/elsi_interface")
  message(STATUS "... Configuring existing ELSI sources in ${PROJECT_SOURCE_DIR}/External/ELSI-project/elsi_interface")
else()
  message(STATUS "... Fetching ELSI sources from Git repository")
endif()

FetchContent_Declare(
  elsi
  GIT_REPOSITORY https://gitlab.com/siesta-project/ecosystem/elsi_interface.git
  # Keep this in sync with submodule commit reference
  GIT_TAG bc33fce5c899acfbb0f
  ## GIT_TAG  siesta-adaptations
  ## For later -- OVERRIDE_FIND_PACKAGE
  )

FetchContent_MakeAvailable(elsi)

set(ELSI_FOUND TRUE)

if (NOT TARGET elsi::elsi)
  message(STATUS "-- Creating elsi::elsi target")
  add_library(elsi::elsi ALIAS elsi)
endif()

# Pass result variables upstream

set(ELSI_FOUND ${ELSI_FOUND} PARENT_SCOPE)
set(ELSI_HAS_PEXSI ${ELSI_HAS_PEXSI} PARENT_SCOPE)
set(ELSI_HAS_EXTERNAL_ELPA ${ELSI_HAS_EXTERNAL_ELPA} PARENT_SCOPE)
set(ELSI_HAS_CUDA ${ELSI_HAS_CUDA} PARENT_SCOPE)
set(ELSI_ELPA_HAS_GPU_SUPPORT ${ELSI_ELPA_HAS_GPU_SUPPORT} PARENT_SCOPE)
set(ELPA_HAS_GPU_SUPPORT ${ELPA_HAS_GPU_SUPPORT} PARENT_SCOPE)
set(ELSI_ELPA_GPU_STRING ${ELSI_ELPA_GPU_STRING} PARENT_SCOPE)
set(ELSI_ELPA_REAL_GPU_KERNEL ${ELSI_ELPA_REAL_GPU_KERNEL} PARENT_SCOPE)
set(ELSI_ELPA_COMPLEX_GPU_KERNEL ${ELSI_ELPA_COMPLEX_GPU_KERNEL} PARENT_SCOPE)

list(POP_BACK CMAKE_MESSAGE_CONTEXT)

=== Tests/12.Solvers/CMakeLists.txt ===
# 
siesta_subtest(si_default)
siesta_subtest(si_procy)
siesta_subtest(si_mrrr)
siesta_subtest(si_omm1)
siesta_subtest(si_omm2)
siesta_subtest(si_on)

if(SIESTA_WITH_ELSI)
 siesta_subtest(si-qdot-elsi-elpa LABELS long)
 siesta_subtest(si-qdot-elsi-elpa-1stage LABELS long)
 if(ELSI_ELPA_HAS_GPU_SUPPORT)
   siesta_subtest(si-qdot-elsi-elpa-gpu LABELS long)
   siesta_subtest(si-qdot-elsi-elpa-1stage-gpu LABELS long)
 endif()
 siesta_subtest(sih-elsi LABELS simple)
 if(ELSI_HAS_PEXSI)
   siesta_subtest(si-qdot-elsi-pexsi LABELS long MPI_MINPROCS 2)
 endif()
endif()

if(SIESTA_WITH_PEXSI)
  siesta_subtest(si-qdot-pexsi-native FILES_SETUP coords.Si987H372.fdf LABELS long MPI_MINPROCS 2)
endif()

if(SIESTA_WITH_ELPA)
  siesta_subtest(si-qdot-elpa-native FILES_SETUP coords.Si987H372.fdf LABELS long)
  siesta_subtest(si-qdot-elpa-native-1stage FILES_SETUP coords.Si987H372.fdf si-qdot-elpa-native.fdf LABELS long)
  if(SIESTA_ELPA_HAS_GPU_SUPPORT)
    siesta_subtest(si-qdot-elpa-native-gpu FILES_SETUP si-qdot-elpa-native.fdf coords.Si987H372.fdf LABELS long)
    siesta_subtest(si-qdot-elpa-native-1stage-gpu FILES_SETUP coords.Si987H372.fdf si-qdot-elpa-native.fdf LABELS long)
  endif()
endif()

=== Tests/14.FileIO/CMakeLists.txt ===
#

siesta_subtest(save_outs LABELS simple)
siesta_subtest(save_init_rho)
siesta_subtest(s_only)
siesta_subtest(write_ncdf)
siesta_subtest(denchar)
siesta_subtest(kp_file FILES_SETUP kp_file.KP)
siesta_subtest(save_dm FILES_SETUP save_dm.DM LABELS simple)

=== Tests/17.Wannier90/CMakeLists.txt ===
#
siesta_subtest(wannier FILES_SETUP wannier.nnkp LABELS simple)

if(SIESTA_WITH_WANNIER90)
  siesta_subtest(w90-on-the-fly LABELS long)
  siesta_subtest(graphene_w90 LABELS simple)

  if (SIESTA_TESTS_MPI_NUMPROCS GREATER 2)
    set(small_test_nprocs 2)
  else()
    set(small_test_nprocs ${SIESTA_TESTS_MPI_NUMPROCS})
  endif()
  siesta_subtest(w90-chem-h2 LABELS simple MPI_NPROC ${small_test_nprocs})
endif()

=== Util/COOP/CMakeLists.txt ===
#
# There are several targets in this directory. The 'OBJECT library' idiom
# was needed to avoid ninja complaining about "two paths for the same
# .mod file". Common files are grouped in a pseudo-library object.
#
# This is a major annoyance.
#
set(top_srcdir "${PROJECT_SOURCE_DIR}/Src")

add_library(${PROJECT_NAME}.coop_common_objs OBJECT
        ${top_srcdir}/alloc.F90
        ${top_srcdir}/parallel.F
        ${top_srcdir}/m_io.f
        ${top_srcdir}/moreParallelSubs.F90
        ${top_srcdir}/m_getopts.f90
        ${top_srcdir}/precision.F
        io.f
        subs.f90
        main_vars.f90
        io_hs.f90
        orbital_set.f90
        read_curves.f90
        local_timer.f90
)
target_link_libraries(${PROJECT_NAME}.coop_common_objs
  PUBLIC
    ${PROJECT_NAME}.libunits
    ${PROJECT_NAME}.mpi_macros
  PRIVATE
    ${PROJECT_NAME}.libsys
  )

set(sources_fat
        fat.f90
)
set(sources_mprop
        mprop.f90
)
set(sources_spin_texture
        spin_texture.f90
)

set(sources_read_spin_texture
        read_spin_texture.f90
)

set(sources_dm_creator
        iodm_netcdf.F90
        write_dm.f
        dm_creator.F90
)

siesta_add_executable(${PROJECT_NAME}.fat
   ${sources_fat}
)
target_link_libraries(${PROJECT_NAME}.fat
  PRIVATE
   ${PROJECT_NAME}.coop_common_objs
   ${PROJECT_NAME}.libsys
   )

siesta_add_executable(${PROJECT_NAME}.mprop
   ${sources_mprop}
)
target_link_libraries(${PROJECT_NAME}.mprop
   PRIVATE
   ${PROJECT_NAME}.coop_common_objs
   ${PROJECT_NAME}.libsys
   )

siesta_add_executable(${PROJECT_NAME}.spin_texture
   ${sources_spin_texture}
)
target_link_libraries(${PROJECT_NAME}.spin_texture
   PRIVATE
   ${PROJECT_NAME}.coop_common_objs
   ${PROJECT_NAME}.libsys
   )

siesta_add_executable(${PROJECT_NAME}.read_spin_texture
   ${sources_read_spin_texture}
)

siesta_add_executable(${PROJECT_NAME}.dm_creator
   ${sources_dm_creator}
)

target_link_libraries(${PROJECT_NAME}.dm_creator
   PRIVATE
   ${PROJECT_NAME}.coop_common_objs
   ${PROJECT_NAME}.libsys
   )

if(SIESTA_WITH_NETCDF)
  target_link_libraries(${PROJECT_NAME}.dm_creator
   PRIVATE
   NetCDF::NetCDF_Fortran
 )
  target_compile_definitions(${PROJECT_NAME}.dm_creator
    PRIVATE
    CDF
  )
endif()



if( SIESTA_INSTALL )
  install(
    TARGETS
      ${PROJECT_NAME}.fat
      ${PROJECT_NAME}.mprop
      ${PROJECT_NAME}.spin_texture
      ${PROJECT_NAME}.dm_creator
      ${PROJECT_NAME}.read_spin_texture
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
endif()

=== Util/libsiestaqmmm/CMakeLists.txt ===
set(qmmmtop_srcdir "${PROJECT_SOURCE_DIR}/Src")

set(libsqmmm_sources
  siestaqmmm.F90
  siestaqmmm_m.F90
)

list(
  APPEND
  libsqmmm_sources
  ${qmmmtop_srcdir}/fsockets.f90
  ${qmmmtop_srcdir}/precision.F
  ${qmmmtop_srcdir}/sockets.c
)

add_library(${PROJECT_NAME}-libsiestaqmmm "${libsqmmm_sources}")
set_target_properties(
  ${PROJECT_NAME}-libsiestaqmmm
  PROPERTIES
  VERSION "${PROJECT_VERSION}"
  OUTPUT_NAME "siestaqmmm"
)

install(
  TARGETS ${PROJECT_NAME}-libsiestaqmmm
  RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

target_compile_definitions(
    ${PROJECT_NAME}-libsiestaqmmm
    PUBLIC
    "$<$<BOOL:${SIESTA_WITH_GRID_SP}>:GRID_SP>"
)

target_link_libraries(
  ${PROJECT_NAME}-libsiestaqmmm
  PRIVATE
  $<$<BOOL:${SIESTA_WITH_OPENMP}>:OpenMP::OpenMP_Fortran>
  libfdf::libfdf
)

=== Util/QMMM-driver/Tests/CMakeLists.txt ===
# This is the main engine for SIESTA tests.
include(tests/SiestaTests)

list(APPEND CMAKE_MESSAGE_CONTEXT test)
find_package(Python3
  3.5.0 # subprocess limitation
  COMPONENTS Interpreter
  )

add_subdirectory("WaterDimer")
add_subdirectory("LinkAtom-DiBenzene")
add_subdirectory("QMonly-Benzene")
add_subdirectory("MM-Gly")
add_subdirectory("MM-Ala")
add_subdirectory("Restraints")
add_subdirectory("MM-Fixed")
add_subdirectory("Elecfield")

# Pop back the test context
list(POP_BACK CMAKE_MESSAGE_CONTEXT)

=== Util/TS/tscontour/CMakeLists.txt ===
set(top_srcdir "${PROJECT_SOURCE_DIR}/Src")

set(sources

   tscontour.F90
   local_timer.f90

)
list(
    APPEND
    sources

   # Required (but not used) dependencies
   ${top_srcdir}/atm_types.f
   ${top_srcdir}/atmfuncs.f
   ${top_srcdir}/atmparams.f
   ${top_srcdir}/atom.F
   ${top_srcdir}/atomlist.f
   ${top_srcdir}/atom_options.F90
   ${top_srcdir}/basis_specs.f
   ${top_srcdir}/basis_types.f
   ${top_srcdir}/bessph.f
   ${top_srcdir}/cellsubs.f
   ${top_srcdir}/chkdim.f
   ${top_srcdir}/class_Geometry.F90
   ${top_srcdir}/class_Pair_Geometry_SpData2D.F90
   ${top_srcdir}/class_Fstack_Pair_Geometry_SpData2D.F90
   ${top_srcdir}/chemical.f
   ${top_srcdir}/dftu_specs.f
   ${top_srcdir}/domain_decom.F
   ${top_srcdir}/hamann.f90
   ${top_srcdir}/idiag.f
   ${top_srcdir}/interpolation.f90
   ${top_srcdir}/minvec.f
   ${top_srcdir}/mmio.F
   ${top_srcdir}/m_fft_gpfa.F
   ${top_srcdir}/m_filter.f90
   ${top_srcdir}/m_vee_integrals.F90
   ${top_srcdir}/parallelsubs.F
   ${top_srcdir}/periodic_table.f
   ${top_srcdir}/printmatrix.F
   ${top_srcdir}/pspltm1.F
   ${top_srcdir}/qsort.F
   ${top_srcdir}/sparse_matrices.F90
   ${top_srcdir}/spatial.F
   ${top_srcdir}/radial.f
   ${top_srcdir}/radfft.f
   ${top_srcdir}/spher_harm.f
   ${top_srcdir}/siesta_cml.f90
   ${top_srcdir}/schecomm.F
   ${top_srcdir}/xml.f


   ${top_srcdir}/precision.F
   ${top_srcdir}/parallel.F
   ${top_srcdir}/alloc.F90
   ${top_srcdir}/pxf.F90
   ${top_srcdir}/m_io.f
   ${top_srcdir}/memory_log.F90
   ${top_srcdir}/memory.F
   ${top_srcdir}/io.f
   ${top_srcdir}/intrinsic_missing.F90
   ${top_srcdir}/files.f
   ${top_srcdir}/reclat.f
   ${top_srcdir}/m_char.f90
   ${top_srcdir}/m_os.F90
   ${top_srcdir}/geom_helper.f90
   ${top_srcdir}/class_OrbitalDistribution.F90
   ${top_srcdir}/class_Data2D.F90
   ${top_srcdir}/class_Sparsity.F90
   ${top_srcdir}/class_SpData2D.F90
   ${top_srcdir}/class_Data1D.F90
   ${top_srcdir}/class_SpData1D.F90
   ${top_srcdir}/io_sparse.F90
   ${top_srcdir}/m_iodm.F90
   ${top_srcdir}/option_charges.f90
   ${top_srcdir}/siesta_options.F90
   ${top_srcdir}/interpolation.f90
   ${top_srcdir}/xml.f
   ${top_srcdir}/radial.f
   ${top_srcdir}/atm_types.f
   ${top_srcdir}/spher_harm.f
   ${top_srcdir}/atmfuncs.f
   ${top_srcdir}/atmparams.f
   ${top_srcdir}/atom_options.F90
   ${top_srcdir}/basis_types.f
   ${top_srcdir}/chemical.f
   ${top_srcdir}/periodic_table.f
   ${top_srcdir}/pspltm1.F
   ${top_srcdir}/basis_specs.f
   ${top_srcdir}/hamann.f90
   ${top_srcdir}/bessph.f
   ${top_srcdir}/m_fft_gpfa.F
   ${top_srcdir}/radfft.f
   ${top_srcdir}/m_filter.f90
   ${top_srcdir}/atom.F
   ${top_srcdir}/m_cite.F90
   ${top_srcdir}/m_spin.F90
   ${top_srcdir}/m_vee_integrals.F90
   ${top_srcdir}/dftu_specs.f
   ${top_srcdir}/siesta_geom.F90
   ${top_srcdir}/atomlist.f
   ${top_srcdir}/densematrix.f90
   ${top_srcdir}/m_ts_global_vars.f90
   ${top_srcdir}/m_energies.F90
   ${top_srcdir}/arw.f
   ${top_srcdir}/chkdim.f
   ${top_srcdir}/m_region.F90
   ${top_srcdir}/fdf_extra.F90
   ${top_srcdir}/kpoint_convert.f90
   ${top_srcdir}/find_kgrid.F
   ${top_srcdir}/kpoint_t.F90
   ${top_srcdir}/sorting.f
   ${top_srcdir}/m_mesh_node.F90
   ${top_srcdir}/m_mpi_utils.F
   ${top_srcdir}/mneighb.f
   ${top_srcdir}/errorf.f
   ${top_srcdir}/m_trialorbitalclass.f90
   ${top_srcdir}/matel_registry.F90
   ${top_srcdir}/matel.F90
   ${top_srcdir}/matel_params.f90
   ${top_srcdir}/matel_table.F90
   ${top_srcdir}/matel_ylm.F90
   ${top_srcdir}/printmatrix.F
   ${top_srcdir}/schecomm.F
   ${top_srcdir}/class_Geometry.F90
   ${top_srcdir}/class_Pair_Geometry_SpData2D.F90
   ${top_srcdir}/class_Fstack_Pair_Geometry_SpData2D.F90
   ${top_srcdir}/sparse_matrices.F90
   ${top_srcdir}/domain_decom.F
   ${top_srcdir}/spatial.F
   ${top_srcdir}/parallelsubs.F
   ${top_srcdir}/m_occ_proj_dftu.F90
   ${top_srcdir}/m_pot_dftu.F90
   ${top_srcdir}/m_dftu_so.F90
   ${top_srcdir}/qsort.F
   ${top_srcdir}/mmio.F
   ${top_srcdir}/propor.f
   ${top_srcdir}/volcel.f
   ${top_srcdir}/debugmpi.F
   ${top_srcdir}/m_uuid.f90
   ${top_srcdir}/object_debug.F90
   ${top_srcdir}/class_Fstack_Data1D.F90
   ${top_srcdir}/m_sparse.F90
   ${top_srcdir}/ncdf_io.F90
   ${top_srcdir}/ts_io_hs.F90
   ${top_srcdir}/io_hsx.F90
   ${top_srcdir}/m_handle_sparse.F90
   ${top_srcdir}/m_mixing.F90
   ${top_srcdir}/m_mixing_scf.F90
   ${top_srcdir}/m_geom_aux.f90
   ${top_srcdir}/m_geom_box.f90
   ${top_srcdir}/m_geom_coord.f90
   ${top_srcdir}/m_geom_plane.f90
   ${top_srcdir}/m_geom_square.f90
   ${top_srcdir}/m_geom_objects.f90
   ${top_srcdir}/bloch_unfold.F90
   ${top_srcdir}/create_Sparsity_SC.F90
   ${top_srcdir}/m_gauss_fermi_inf.f90
   ${top_srcdir}/m_ts_io_ctype.f90
   ${top_srcdir}/m_ts_cctype.f90
   ${top_srcdir}/m_ts_chem_pot.F90
   ${top_srcdir}/m_ts_iodm.F90
   ${top_srcdir}/ts_electrode.F90
   ${top_srcdir}/m_ts_tdir.f90
   ${top_srcdir}/m_ts_hartree.F90
   ${top_srcdir}/m_ts_aux.F90
   ${top_srcdir}/m_ts_method.f90
   ${top_srcdir}/ts_charge.F90
   ${top_srcdir}/m_gauss_quad.f90
   ${top_srcdir}/m_integrate.f90
   ${top_srcdir}/m_ts_io_contour.f90
   ${top_srcdir}/m_ts_contour_neq.f90
   ${top_srcdir}/m_ts_weight.F90
   ${top_srcdir}/m_interpolate.F90
   ${top_srcdir}/m_gauss_fermi_17.f90
   ${top_srcdir}/m_gauss_fermi_18.f90
   ${top_srcdir}/m_gauss_fermi_19.f90
   ${top_srcdir}/m_gauss_fermi_20.f90
   ${top_srcdir}/m_gauss_fermi_22.f90
   ${top_srcdir}/m_gauss_fermi_24.f90
   ${top_srcdir}/m_gauss_fermi_26.f90
   ${top_srcdir}/m_gauss_fermi_28.f90
   ${top_srcdir}/m_gauss_fermi_30.f90
   ${top_srcdir}/m_ts_contour_eq.f90
   ${top_srcdir}/ts_dq.F90
   ${top_srcdir}/m_ts_contour.f90
   ${top_srcdir}/create_Sparsity_Union.F90
   ${top_srcdir}/m_ts_elec_se.F90
   ${top_srcdir}/m_sparsity_handling.F90
   ${top_srcdir}/class_TriMat.F90
   ${top_srcdir}/m_ts_debug.F90
   ${top_srcdir}/m_ts_sparse.F90
   ${top_srcdir}/m_ts_mumps_init.F90
   ${top_srcdir}/m_ts_options.F90
   ${top_srcdir}/nag.f

)

siesta_add_executable(${PROJECT_NAME}.tscontour
   ${sources}
  NAMESPACE_TARGET tscontour
)


target_link_libraries(
  ${PROJECT_NAME}.tscontour
  PRIVATE
  $<$<BOOL:${SIESTA_WITH_NETCDF}>:NetCDF::NetCDF_Fortran>
  libfdf::libfdf
  libpsml::libpsml
  libgridxc::libgridxc
  ${PROJECT_NAME}.libncps
  ${PROJECT_NAME}.libpsop
  ${PROJECT_NAME}.libsys
  ${PROJECT_NAME}.libunits
  ${PROJECT_NAME}.mpi_macros
  "$<$<BOOL:${SIESTA_WITH_NCDF}>:${PROJECT_NAME}.libncdf>"
  "$<$<BOOL:${SIESTA_WITH_NCDF}>:${PROJECT_NAME}.libfdict>"
   LAPACK::LAPACK
)

target_compile_definitions(
  ${PROJECT_NAME}.tscontour
  PRIVATE
  "$<$<BOOL:${SIESTA_WITH_NETCDF}>:CDF>"
  "$<$<BOOL:${SIESTA_WITH_NCDF}>:NCDF>"
  "$<$<BOOL:${SIESTA_WITH_NCDF}>:NCDF_4>"
  "$<$<BOOL:${SIESTA_WITH_NCDF_PARALLEL}>:NCDF_PARALLEL>"
)

if( SIESTA_INSTALL )
  install(
    TARGETS ${PROJECT_NAME}.tscontour
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
endif()

=== Util/QMMM-driver/Tests/MM-Gly/CMakeLists.txt ===
siestaqmmm_subtest(gly MMONLY LABELS qmmm FILES_SETUP amber.parm)

=== Util/SiestaSubroutine/SimpleTest/Src/CMakeLists.txt ===
#
# FIXME: The names in this directory are very confusing
#        Only a subset of the executables are built
#
set(top_srcdir "${PROJECT_SOURCE_DIR}/Src")


#
# Create auxiliary libraries, with their own module directories,
# to satisfy Ninja. This is also good practice in general
#
# -- Sockets
siesta_add_library(${PROJECT_NAME}.sockets-dispatch
  NO_LINKER_FLAGS
  OBJECT
    ${top_srcdir}/fsiesta_sockets.F90
    ${top_srcdir}/fsockets.f90
    ${top_srcdir}/sockets.c
    ${top_srcdir}/posix_calls.f90
)
set_target_properties(${PROJECT_NAME}.sockets-dispatch
  PROPERTIES
  Fortran_MODULE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/sockets-include")

target_include_directories(${PROJECT_NAME}.sockets-dispatch
  INTERFACE
  "${CMAKE_CURRENT_BINARY_DIR}/sockets-include")

# -- Pipes
siesta_add_library(${PROJECT_NAME}.pipes-dispatch
  NO_LINKER_FLAGS
  OBJECT
    ${top_srcdir}/fsiesta_pipes.F90
    ${top_srcdir}/pxf.F90
    ${top_srcdir}/posix_calls.f90
)
set_target_properties(${PROJECT_NAME}.pipes-dispatch
  PROPERTIES
  Fortran_MODULE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/pipes-include")
target_include_directories(${PROJECT_NAME}.pipes-dispatch
  INTERFACE
  "${CMAKE_CURRENT_BINARY_DIR}/pipes-include")

if (SIESTA_WITH_MPI)

# -- MPI dispatch -- uses 'libsiesta'
siesta_add_library(${PROJECT_NAME}.mpi-dispatch
  NO_LINKER_FLAGS
  OBJECT
    ${top_srcdir}/fsiesta_mpi.F90
)
target_link_libraries(${PROJECT_NAME}.mpi-dispatch PUBLIC ${PROJECT_NAME}.libsiesta)

set_target_properties(${PROJECT_NAME}.mpi-dispatch
  PROPERTIES
  Fortran_MODULE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/mpi-include")
target_include_directories(${PROJECT_NAME}.mpi-dispatch
  INTERFACE
  "${CMAKE_CURRENT_BINARY_DIR}/mpi-include")

# ----
#
# Phonons: Uses the MPI dispatch
#
siesta_add_executable(${PROJECT_NAME}.phonons
  phonons.F90
)
target_link_libraries(${PROJECT_NAME}.phonons PRIVATE ${PROJECT_NAME}.mpi-dispatch)

if(MPI_Fortran_HAVE_F08_MODULE)
  siesta_add_executable(${PROJECT_NAME}.phonons-f08
  phonons.F90
  )
  target_link_libraries(${PROJECT_NAME}.phonons-f08 PRIVATE ${PROJECT_NAME}.mpi-dispatch)
  target_compile_definitions(${PROJECT_NAME}.phonons-f08 PRIVATE CLIENT_USES_F08)
endif()

#
# Test in which not all ranks are involved in siesta_launch
#
siesta_add_executable(${PROJECT_NAME}.comm_test
  comm_test.f90)
target_link_libraries(${PROJECT_NAME}.comm_test PRIVATE ${PROJECT_NAME}.mpi-dispatch)

# Simple MPI-aware driver
siesta_add_executable(${PROJECT_NAME}.mpi_driver
  simple_mpi_parallel.f90
)
target_link_libraries(${PROJECT_NAME}.mpi_driver PRIVATE ${PROJECT_NAME}.mpi-dispatch)


# Sockets interface to parallel-version of Siesta
siesta_add_executable(${PROJECT_NAME}.sockets_parallel
  simple_parallel.f90)
target_link_libraries(${PROJECT_NAME}.sockets_parallel PRIVATE ${PROJECT_NAME}.sockets-dispatch)


# Pipes interface to parallel-version of Siesta
siesta_add_executable(${PROJECT_NAME}.pipes_parallel
  simple_parallel.f90
)
target_link_libraries(${PROJECT_NAME}.pipes_parallel PRIVATE ${PROJECT_NAME}.pipes-dispatch)


if( SIESTA_INSTALL )
  install(
    TARGETS
    ${PROJECT_NAME}.phonons ${PROJECT_NAME}.pipes_parallel
      ${PROJECT_NAME}.sockets_parallel ${PROJECT_NAME}.mpi_driver
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
  if(MPI_Fortran_HAVE_F08_MODULE)
    install(
      TARGETS
      ${PROJECT_NAME}.phonons-f08
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
      )
  endif()
endif()
endif(SIESTA_WITH_MPI)

siesta_add_executable(${PROJECT_NAME}.sockets_serial
  simple_serial.f90)
target_link_libraries(${PROJECT_NAME}.sockets_serial PRIVATE ${PROJECT_NAME}.sockets-dispatch)

siesta_add_executable(${PROJECT_NAME}.pipes_serial
  simple_serial.f90)
target_link_libraries(${PROJECT_NAME}.pipes_serial PRIVATE ${PROJECT_NAME}.pipes-dispatch)

if( SIESTA_INSTALL )
  install(
    TARGETS
      ${PROJECT_NAME}.pipes_serial
      ${PROJECT_NAME}.sockets_serial
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=siesta
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.4.1
pkgrel=2
pkgdesc="A first-principles materials simulation code using DFT. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64')
url='https://siesta-project.org/siesta'
msys2_repository_url="https://gitlab.com/siesta-project/siesta"
msys2_references=(
  'aur: siesta'
)
license=('spdx:GPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-s-dftd3"
         "${MINGW_PACKAGE_PREFIX}-libfdf"
         "${MINGW_PACKAGE_PREFIX}-libgridxc"
         "${MINGW_PACKAGE_PREFIX}-libpsml"
         #"${MINGW_PACKAGE_PREFIX}-libxc"
         "${MINGW_PACKAGE_PREFIX}-mctc-lib"
         "${MINGW_PACKAGE_PREFIX}-netcdf-fortran"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-scalapack"
         "${MINGW_PACKAGE_PREFIX}-xmlf90")
makedepends=("${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-msmpi"
             "${MINGW_PACKAGE_PREFIX}-python")
_w90_ver=3.1.0
source=("https://gitlab.com/siesta-project/siesta/-/releases/${pkgver}/downloads/${_realname}-${pkgver}.tar.gz"
        "https://github.com/wannier-developers/wannier90/archive/v${_w90_ver}/wannier90-${_w90_ver}.tar.gz"
        "001-fix-build-on-mingw.patch")
sha256sums=('531ed2fa021d6a733739b5c1ba7d8cf32fe5aee3df6774a8e748ba3d6faaebcc'
            '40651a9832eb93dec20a8360dd535262c261c34e13c41b6755fa6915c936b254'
            '6c5c587e1b66b94391e090688edc36daca9033360113148df4a5c43b8f619752')
noextract=("wannier90-${_w90_ver}.tar.gz")

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -Np1 -i "${srcdir}"/001-fix-build-on-mingw.patch
}

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  local _fflags=""
  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    _fflags+=" -fallow-invalid-boz"
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    _fflags+=" -march=x86-64-v3"
    CFLAGS+=" -march=x86-64-v3"
  fi

  FFLAGS="${_fflags}" \
  WANNIER90_PACKAGE="${srcdir}"/wannier90-${_w90_ver}.tar.gz \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DSIESTA_SHARED_LIBS=ON \
      -DSIESTA_WITH_ELPA=OFF \
      -DSIESTA_WITH_ELSI=OFF \
      -DSIESTA_WITH_FLOOK=OFF \
      -DSIESTA_WITH_IPO=OFF \
      -DSIESTA_SET_RPATH=OFF \
      -DSIESTA_WITH_FFTW=ON \
      -DSIESTA_WITH_LIBXC=ON \
      -DSIESTA_WITH_MPI=ON \
      -DSIESTA_WITH_NETCDF=ON \
      -DSIESTA_WITH_OPENMP=ON \
      -DSIESTA_WITH_WANNIER90=ON \
      -DSIESTA_TESTS=OFF \
      -DBLA_VENDOR=OpenBLAS \
      -DSCALAPACK_LIBRARY=${MINGW_PREFIX}/lib/libscalapack.dll.a \
      -DFortran_FLAGS_RELEASE="-O3" \
      -DC_FLAGS_RELEASE="-O3" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"
}
